#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES


acs::check_access($username, $password, $q->param('username'), $q->param('password'));


##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "modified_opp") {&modified_opp;}
if ($q->param('fct') eq "apply_changes") {&apply_changes;}

##################################################################################



sub apply_changes
{

### CHECK IF UPLOAD DIR EXISTS
	$upload_dir = "$web_dir/imagefiles";
	if ((-e $upload_dir) < 1) {
	mkdir ($upload_dir, $default_permissions);
	chmod($default_permissions,"$upload_dir","$upload_dir"); }


### GET EXTRA FIELD DETAILS

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;
	
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$linknrs = $q->param('itemnrs');
for ($ms = 0; $ms < $linknrs; $ms++)
	{
	
	$iname = "C" . $ms;
	$mdfid = $q->param($iname);
	
	$title = "title" . $ms; $title = $q->param($title); $title =~ s/'/\\'/g; 
	$description = "description" . $ms; $description = $q->param($description); $description =~ s/'/\\'/g; 
	$keywords = "keywords" . $ms; $keywords = $q->param($keywords); $keywords =~ s/'/\\'/g; 
	$url = "url" . $ms; $url = $q->param($url); $url =~ s/'/\\'/g; 
	$name = "name" . $ms; $name = $q->param($name); $name =~ s/'/\\'/g; 
	$email = "email" . $ms; $email = $q->param($email); $email =~ s/'/\\'/g; 
	$lnkpassword = "password" . $ms; $lnkpassword = $q->param($lnkpassword); $lnkpassword =~ s/'/\\'/g; 


	### CHECK IF NEW IMAGE IS BEING UPLOADED OR DELETED
		$imgn = "image" . $ms;
		$imgdel = "image_del_box" . $ms;
		$origid_box = "olnkid" . $ms; $origid = $q->param($origid_box);
	
		if ($q->param($imgn) ne "")  ### IF NEW IMAGE UPLOADED
		{
		push (@imgvar, "$mdfid" . ":" . $ms . ":" . "U" . ":" . $origid);
		}
		elsif ($q->param($imgdel) eq "Y")
		{
		push (@imgvar, "$mdfid" . ":" . $ms . ":" . "D" . ":" . $origid);
		}
		
		#########
	
		$key_add_crit = "";
		foreach $k_item (@akeys)
			{
			($keyname1, $visible1, $size1, $searched1, $description1, $na1, $imagef1, $numberfield1, $req1) = split (/\t/, $k_item);
			$this_key = $keyname1 . $ms;
			
			$thiskeycrit = $q->param($this_key);
			
			if ($numberfield1 eq "Upload")
				{
				$lnkid_name = "olnkid" . $ms;
				$curr_lnkid = $q->param($lnkid_name);
				$up_del_key = $keyname1 . "_del" . $ms;
				
					### IF NEW UPLOAD
					if ($thiskeycrit ne "") 
						{ 
						$upfextension = &upload_new_key_file($this_key, $keyname1, $curr_lnkid); 
						$keyfname = "$keyname1" . "_cust"; $key_add_crit = $key_add_crit . "," . $keyfname . "= '$upfextension'";
						}
					### IF DEL
					elsif ($q->param($up_del_key) eq "Y") 
						{
						&del_modified_image($this_key, $keyname1, $curr_lnkid); 
						$keyfname = "$keyname1" . "_cust"; $key_add_crit = $key_add_crit . "," . $keyfname . "= ''";
						}
				
				}
				else
				{
				$thiskeycrit =~ s/'/\\'/g;
				$keyfname = "$keyname1" . "_cust";
				$key_add_crit = $key_add_crit . "," . $keyfname . "= '$thiskeycrit'";
				}
				
			}
			

		$sql = "UPDATE modified SET  	title = '$title',
												description = '$description',
												keywords = '$keywords',
												url = '$url',
												name = '$name',
												email = '$email',
												lnkpassword = '$lnkpassword'
												
												$key_add_crit
												
												WHERE mdfid = '$mdfid'
					 ";		
	
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
	}



### DO IMAGE MODIFICATIONS (UPLOADS / DELETIONS)

$ms = 0;
foreach $item (@imgvar)
	{
	($mdfid, $boxv, $updel) = split (/:/, $item);
	$sqlsel = $sqlsel . " (mdfid = '$mdfid') OR";
	$ms++;
	}


if ($ms > 0) ### GET ORIGINAL NOTES
{
	$sqlsel = substr($sqlsel, 0, length($sqlsel) -2);

	$sql = "SELECT * FROM modified WHERE $sqlsel";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	while ( @row = $sth->fetchrow() )
		{
		  $objn = "N" . $row[0];
		  @rnotes = split (/:::IMGF:::/, $row[11]);
		  
		  $nrnu =  @rnotes;
		  
		  if ($nrnu > 0)
		  	{
		  	$notes{$objn} = $rnotes[0];
		  	}
		  	else
		  	{
		  	$notes{$objn} = $row[11];
		  	}
		}
} 


#### DO UPLOAD IMAGE CHANGES IF ANY

$ms = 0;
foreach $item (@imgvar)
	{
	$sql = "";
	($mdfid, $boxv, $updel, $origid) = split (/:/, $item);
	
		if ($updel eq "U") ### UPLOAD IMAGE
			{
			$imagebname = "image" . $boxv;
			$upload_filename = $q->param($imagebname);
			$upload_filename =~ s/.*[\/\\](.*)/$1/;
			(@fext) = split (/\./, $upload_filename);
			$fnr = @fext;
			$fextension = $fext[$fnr -1];
			
			($origr, $tmp) = split(/\./, $origid);
			
			$ufname = "$web_dir/imagefiles/m_" . $origr . "." . $fextension;
			
			### DO UPLOAD
			$upload_filehandle = $q->param($imagebname);
			open UPLOADFILE, ">$ufname"; 
				binmode UPLOADFILE; 
					while ( <$upload_filehandle> )
					 {
				    print UPLOADFILE;
					 } 	
				close UPLOADFILE;		

			#### UPDATE WHAT WE HAVE JUST DONE TO DB
			$notesobj = "N" . $mdfid;
			$update_crit = $notes{$notesobj};
		
			$origr = $origr . "." . $fextension;
			if ($origid !~ /\./) { $origid = ""; }
		
			$update_crit = $update_crit . ":::IMGF:::" . "m_" . $origr . ":::IMGF:::" . $origid;
			$update_crit =~ s/'/\\'/g; 
			$sql = "UPDATE modified SET notes = '$update_crit' WHERE mdfid = '$mdfid'";
			#print "--> $sql <BR>";
			}
			elsif ($updel eq "D") ### SET IMAGE TO BE DELETED
			{
			$notesobj = "N" . $mdfid;
			$update_crit = $notes{$notesobj};
			$update_crit = $update_crit . ":::IMGF:::" . "DEL" . ":::IMGF:::" . $origid;
			$update_crit =~ s/'/\\'/g; 
			$sql = "UPDATE modified SET notes = '$update_crit' WHERE mdfid = '$mdfid'";
			#print "--> $update_crit <BR>";
			}
		
		if ($sql ne "")
			{
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
			$rows = $sth->rows();
			}
			
	$ms++;
	}


$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_modif.gif", "Your changes has been saved.", qq[
<a href="$admin_url/admin18.cgi">Click Here to Continue</a>
]);
 

print <<END_OF_SV;

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

END_OF_SV

}




sub del_modified_image
{

($currkeyname, $orig_key, $uplnkid) = @_;

$delfname = "$orig_key" . ".";

opendir(DDR,"$web_dir/edt/tmp/$uplnkid");
my @bdfiles = readdir(DDR);
closedir (DDR); 

	foreach $ditem (@bdfiles)
		{
		if (substr($ditem, 0, length($delfname)) eq $delfname)
			{
			unlink ("$web_dir/edt/tmp/$uplnkid/$ditem");
			}
		}

}



sub upload_new_key_file
{
($ef_key, $orig_u_key, $uplnkid) = @_;

&mkdirps("$web_dir/edt");
&mkdirps("$web_dir/edt/tmp");
&mkdirps("$web_dir/edt/tmp/$uplnkid");

$ufileext = &get_file_extension($q->param($ef_key));

$ufname = "$web_dir/edt/tmp/$uplnkid/$orig_u_key" . "." . $ufileext;

$upload_filehandle = $q->param($ef_key);
	open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
			while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;		

return ($ufileext);
}




sub get_file_extension
{
($fullnamem) = @_;

my @fext = split (/\./, $fullnamem);
$fnr = @fext;
$ret_ext = $fext[$fnr -1];

return($ret_ext);
} 






sub mkdirps
{
my ($dir_to_create) = @_;

if ((-e $dir_to_create) < 1) 
	{
	mkdir ($dir_to_create, $default_permissions);
	chmod($default_permissions,$dir_to_create); 
	}

}






sub modified_opp
{

$linknrs = $q->param('itemnrs');

for ($ms = 0; $ms < $linknrs; $ms++) 
	{
	$iname = "C" . $ms;
	$iname = $q->param($iname);
	if ($iname ne "")	{$item_selected = "true";}
	}


if ($item_selected ne "true"){acs::problem_popup("You have to select at least one item.");}

if ($q->param('faction') eq "approve"){&approve_links();}
if ($q->param('faction') eq "approve_email"){&approve_links("EMAIL");}

if ($q->param('faction') eq "discard"){&discard_links();}
if ($q->param('faction') eq "discard_email"){&discard_links("EMAIL");}

if ($q->param('faction') eq "edit"){&edit_modified;}

}






sub edit_modified
{

$gsettings = new_gsettings acs;
if (($gsettings->{image_width} > 0) and ($gsettings->{image_height} > 0))
	{
	$width = $gsettings->{image_width};
	$height = $gsettings->{image_height};
	$imgwh = qq[width="$width" height="$height"];
	}


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

#$sql = "SELECT * FROM modified WHERE ";

$sql = "SELECT A.*, B.image FROM modified AS A, links AS B WHERE (A.lnkid = B.lnkid) AND ( ";

for ($ms = 0; $ms < $linknrs; $ms++) 
	{
	$iname = "C" . $ms;
	$iname = $q->param($iname);
	if ($iname ne "")
		{
		($mdfid, $lnkid) = split (/-/, $iname);
		$sql = $sql . " (A.mdfid = '$mdfid') or";
		}
	}
	$sql = substr($sql, 0, length($sql) - 2);
	$sql = $sql .")";


$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$rows = $sth->rows();

$itecnt = 0;


### GET KEYS
$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys; $knr = $knr - 1;
if ($knr < 1) { $knr = 0; }


while ( @row = $sth->fetchrow() )
	{

	$title_name = "title" . $itecnt;
	$title_val = $row[3];
	
	$description_name = "description" . $itecnt;
	$description_val = $row[4];
	
	$keywords_name = "keywords" . $itecnt;
	$keywords_val = $row[5];
	
	$url_name = "url" . $itecnt;
	$url_val = $row[6];
	
	$name_name = "name" . $itecnt;
	$name_val = $row[7];
	
	$email_name = "email" . $itecnt;
	$email_val = $row[8];
	
	$password_name = "password" . $itecnt;
	$password_val = $row[10];
	
	$itemname = "C" . $itecnt;

	$image_browse = "image" . $itecnt;

	###########
	
	$keydata = acs::get_file_contents("$data_dir/keys.dat");
	@akeys = split (/\n/, $keydata);
	$knr = @akeys;
	
	$extra_keys = "";
	$rnumber = 12;
	
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item);

		$this_keyname = $keyname . $itecnt;
		
		if ($numberfield eq "Upload")
			{
			
			$del_option = ""; $del_option_name = "";
			if ($row[$rnumber] ne "") 
					{
					$del_option_name = $keyname . "_del" . $itecnt;
					$up_file_name = qq[<b>Filename: <a href="$web_url/edt/tmp/$row[1]/$keyname.$row[$rnumber]" target="_blank">$web_url/edt/tmp/$row[1]/$keyname.$row[$rnumber]</a></b>];
					$del_option = qq[<BR>$up_file_name<BR><input type="checkbox" name="$del_option_name" value="Y"> Delete this File?];
					}
			
			$inputbox = qq[<input type="file" name="$this_keyname" size="30" style="width:100%">$del_option];
			}
			else
			{
			if ($size > 255)
				{
				$inputbox = "<textarea rows=\"3\" name=\"$this_keyname\" cols=\"28\" style=\"width:100%\">$row[$rnumber]</textarea>";
				}
				else
				{
				$inputbox = "<input type=\"text\" name=\"$this_keyname\" size=\"30\" value=\"$row[$rnumber]\" style=\"width:100%\">";
				}
			}
		
$extra_keys = $extra_keys . <<END_OF_EK;
  <tr>
    <td width="133" class="normaltext" valign="top" bgcolor="#F5F5FA"><b>$description:</b></td>
    <td width="640" class="normaltext" valign="top" bgcolor="#F5F5FA">$inputbox</td>
  </tr>
END_OF_EK
		
		$rnumber++;
		}

		$image_to_show = ""; $del_image_cbox = "";

		#### IF A NEW IMAGE WAS UPLOADED
		if ($row[11] =~ /:::IMGF:::/)
			{
			($notes, $imgfilename, $old_imgfilename) = split (/:::IMGF:::/, $row[11]);
			
			if ($imgfilename ne "DEL")
				{
				$image_to_show = "$web_url/imagefiles/$imgfilename";
				$image_to_show = qq[<img src="$image_to_show" $imgwh><BR>];
				$imagedel = image_del_box . $itecnt;
				$del_image_cbox = qq[<span class="normaltext">Delete Image? <input type="checkbox" name="$imagedel" value="Y"></span><BR><BR>];
				}
			
			}
		elsif ($row[$knr + 12] ne "")  #### IF LINK HAS AN IMAGE
			{
			$img_fname = "$web_url/imagefiles/" . $row[1] . "." . $row[$knr + 12];
			$image_to_show = qq[<img src="$img_fname" $imgwh><BR>];
			
			$imagedel = image_del_box . $itecnt;
			$del_image_cbox = qq[<span class="normaltext">Delete Image? <input type="checkbox" name="$imagedel" value="Y"></span><BR><BR>];
			}


		$imgfilename = ""; $old_imgfilename = "";
		if ($row[11] =~ /:::IMGF:::/)
			{
			($notes, $imgfilename, $old_imgfilename) = split (/:::IMGF:::/, $row[11]);
			}
			$iname = "i" . $itecnt;
			
			if (($imgfilename ne "") and ($old_imgfilename ne ""))
				{
				$ival = $imgfilename . ":::IMGF:::" . $old_imgfilename;
				}
				else
				{
				$ival = "";
				}
		
		### ORIGINAL LINK ID
		$orig_name = "olnkid" . $itecnt;
		
		#if ($row[13 + 1] ne "") {$orig_val = $row[1] . "." . $row[13 + 1]; }
		#else
		#{$orig_val = $row[1];}
		$orig_val = $row[1];
		
			

$edit_boxes = $edit_boxes . <<END_OF_EDB;

<input type="hidden" name="$itemname" value="$row[0]">
<input type="hidden" name="$iname" value="$ival">
<input type="hidden" name="$orig_name" value="$orig_val">


<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DDDDDD">
  <tr>
    <td width="133" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif">Title:
    </td>
    <td width="640" bgcolor="#FFFFFF" background="$web_url/bar6.gif"><input type="text"
    name="$title_name" size="30" value="$title_val" style="width:100%"> </td>
  </tr>
  <tr>
    <td width="133" valign="top" class="normaltext" bgcolor="#FFFFFF">Description: </td>
    <td width="640" class="normaltext" bgcolor="#FFFFFF"><textarea rows="5"
    name="$description_name" cols="29" style="width:100%">$description_val</textarea> <br>
    Max 255 Characters </td>
  </tr>
  <tr>
    <td width="133" valign="top" class="normaltext" bgcolor="#FFFFFF">Keywords: </td>
    <td width="640" bgcolor="#FFFFFF"><input type="text" name="$keywords_name" size="30"
    value="$keywords_val" style="width:100%"> </td>
  </tr>
  <tr>
    <td width="133" class="normaltext" bgcolor="#FFFFFF">URL: </td>
    <td width="640" bgcolor="#FFFFFF"><input type="text" name="$url_name" size="30"
    value="$url_val" style="width:100%"> </td>
  </tr>
  <tr>
    <td width="133" class="normaltext" bgcolor="#FFFFFF">Your Name: </td>
    <td width="640" bgcolor="#FFFFFF"><input type="text" name="$name_name" size="30"
    value="$name_val" style="width:100%"> </td>
  </tr>
  <tr>
    <td width="133" class="normaltext" bgcolor="#FFFFFF">Email: </td>
    <td width="640" bgcolor="#FFFFFF"><input type="text" name="$email_name" size="30"
    value="$email_val" style="width:100%"> </td>
  </tr>
  <tr>
    <td width="133" class="normaltext" bgcolor="#FFFFFF">Modify Password: </td>
    <td width="640" bgcolor="#FFFFFF"><input type="text" name="$password_name" size="30"
    value="$password_val"> </td>
  </tr>


  <tr>
    <td width="133"  valign="top" class="normaltext" bgcolor="#FFFFFF">Image:</font></td>
    <td width="640" bgcolor="#FFFFFF">
    $image_to_show
    $del_image_cbox
    <input type="file" name="$image_browse" size="70">
    </td>
  </tr>

 
  $extra_keys
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


END_OF_EDB

	$itecnt++;	
	}

#<font face="Arial" size="2">Delete Image? <input type="checkbox" name="delimgbox" value="Y"></font><BR>

$sth->finish;
$dbh->disconnect;

$hbox = acs::get_heading_box("$web_url/ic_modif.gif", "Edit Modified Listings", qq[
Editing $rows listings.<BR>
<b><a href="$admin_url/admin18.cgi">Go Back</a></b>
]); 

print <<END_OF_ED;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

<form method="POST" action="$admin_url/admin18.cgi"  ENCTYPE="multipart/form-data">
  <input type="hidden" name="fct" value="apply_changes">
  <input type="hidden" name="itemnrs" value="$rows">

$hbox
 
$edit_boxes

<input type="submit" value="   Apply Changes   " name="B1">
</form>

</body>
</html>

END_OF_ED

}





sub discard_links
{

my ($email_status) = @_;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql_del = "DELETE FROM modified WHERE ";
$sql_sel = "SELECT * FROM modified WHERE ";

for ($ms = 0; $ms < $linknrs; $ms++) 
	{
	$iname = "C" . $ms;
	$iname = $q->param($iname);
	if ($iname ne "")
		{
		($mdfid, $lnkid) = split (/-/, $iname);
		$sql_del = $sql_del . " (mdfid = '$mdfid') or";
		$sql_sel = $sql_sel . " (mdfid = '$mdfid') or";
		}
	}
	$sql_del = substr($sql_del, 0, length($sql_del) - 2);
	$sql_sel = substr($sql_sel, 0, length($sql_sel) - 2);


if ($email_status ne "") ### GET EMAIL MESSAGE THAT IS TO BE SENT IF LINKS WAS REJECTED TO BE MODIFIED
	{

	### EXTRA FIELDS/KEY OPPS
	$keydata = acs::get_file_contents("$data_dir/keys.dat");
	@akeys = split (/\n/, $keydata);
	$knr = @akeys;
	###

	
	####### GET REJECTION EMAIL
	$emailmsg = acs::get_file_contents("$data_dir/reject_modify.eml");
	@elines = split (/\n/, $emailmsg);
	$from_name = $elines[0];
	$from_email = $elines[1];
	$email_subject = $elines[2];
	$lnc = 0;
			
		$email_message = "";
		foreach $line (@elines)
			{
			if ($lnc > 2)
				{
				$email_message = $email_message . $line . "\n";
				}
			$lnc++;
			}			
	
	}





	######### GET REJECTED MODIFICATIONS FOR MAILING OR IMAGE DELETING IF IMAGES WAS UPLOADED
	$sth = $dbh->prepare($sql_sel);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_sel";}
	while ( @row = $sth->fetchrow() )
		{
		
		$title = $row[3];
		$description = $row[4];
		$url = $row[6];
		$keywords = $row[5];
		$email = $row[8];
		$notes = $row[11];
		
		if ($email_status ne "") ### IF WE NEED TO SEND MAIL THEN PREPARE TEMPLATE
			{
			$to_send_now = $email_message;
			$to_send_now =~ s/%%title%%/$title/g;
			$to_send_now =~ s/%%description%%/$description/g;
			$to_send_now =~ s/%%url%%/$url/g;
			$to_send_now =~ s/%%keywords%%/$keywords/g;
			$to_send_now =~ s/%%email%%/$email/g;

			#### EXTRA FIELDS
			$ekcount = 12;
			foreach $k_item (@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item);
				$ekdata = $row[$ekcount];
				if ($ekdata eq "") { $ekdata = $na; }
				$to_send_now =~ s/%%$keyname%%/$ekdata/g;
				$ekcount++;
				}
			}
	
	
		#### DELETE IMAGE IF IMAGE WAS UPLOADED
		if ($row[11] =~ /:::IMGF:::/)
			{
			($notes, $imgfilename, $old_imgfilename) = split (/:::IMGF:::/, $row[11]);
			
				if ($imgfilename ne "DEL")
					{
					$uploadedimg = "$web_dir/imagefiles/$imgfilename";
					unlink ($uploadedimg);
					}
			}
		

		if ($email_status ne "") ### SEND MAIL IF WE NEED TO DO THAT
			{
			acs::send_email ($from_name, $from_email, $email, $email_subject, $to_send_now);
			}
			
			
		}
	



$sth = $dbh->prepare($sql_del);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_del";}
$rows = $sth->rows();

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_modif.gif", "Modified Link Changes Discarded", qq[
$rows Discarded.<BR>
<a href="$admin_url/admin18.cgi">Click Here to Continue.</a>
]);


print <<END_OF_APPD;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

END_OF_APPD

}







sub approve_links
{
my ($email_status) = @_;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect("$dsn", "$db_username", "$db_password");
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($mysql_hostname eq ""){$dsn2 = "DBI:mysql:$db_name";}else{$dsn2 = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh2 = DBI->connect("$dsn2", "$db_username", "$db_password");
if ( !defined $dbh2 ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM modified WHERE ";
$sql_del = "DELETE FROM modified WHERE ";

for ($ms = 0; $ms < $linknrs; $ms++) 
	{
	$iname = "C" . $ms;
	$iname = $q->param($iname);
	if ($iname ne "")
		{
		($mdfid, $lnkid) = split (/-/, $iname);
		$sql = $sql . " (mdfid = '$mdfid') or";
		$sql_del = $sql_del . " (mdfid = '$mdfid') or";
		}
	}

	$sql = substr($sql, 0, length($sql) - 2);
	$sql_del = substr($sql_del, 0, length($sql_del) - 2);
	
	### SELECT * FROM modified WHERE
	$sth = $dbh->prepare($sql); ### GET MODIFIED LINK DETAILS
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}


	### EXTRA FIELDS/KEY OPPS
	$keydata = acs::get_file_contents("$data_dir/keys.dat");
	@akeys = split (/\n/, $keydata);
	$knr = @akeys;
	###

	$approval_count = 0;
	while ( @row = $sth->fetchrow() ) 
		{
		$approval_count++;
		$lnkid = $row[1]; 
		$title = $row[3]; $title =~ s/'/\\'/g; 
		$description = $row[4]; $description =~ s/'/\\'/g;
		$keywords = $row[5]; $keywords =~ s/'/\\'/g;
		$url = $row[6]; $url =~ s/'/\\'/g;
		$name = $row[7]; $name =~ s/'/\\'/g;
		$email = $row[8]; $email =~ s/'/\\'/g;
		$urldate = $row[9]; $urldate =~ s/'/\\'/g;
		$lnkpassword = $row[10]; $lnkpassword =~ s/'/\\'/g;
		
		
		#### CHANGE IMAGE IF NEW IMAGE WAS UPLOADED
		$image_ext_update = "";
		if ($row[11] =~ /:::IMGF:::/)
			{
			($notes, $imgfilename, $old_imgfilename) = split (/:::IMGF:::/, $row[11]);
			
			if ($imgfilename ne "DEL")
				{
				$changed_img_filename = "$web_dir/imagefiles/$imgfilename";

				### GET NEW IMAGE FILE NAME
				my @fext = split (/\./, $imgfilename);
				$fnr = @fext;
				$fextension = $fext[$fnr -1];
				$new_img_filename = "$web_dir/imagefiles/$lnkid" . "." . $fextension;
				$image_ext_update = "image = '$fextension', ";
				}
				elsif ($imgfilename eq "DEL") ### RECORD LINK ID SO THAT WE CAN UPDATE THE DB
				{
				push (@img_to_rem, $lnkid);
				}
			
			### REMOVE OLD IMAGE
			$old_img_filename = "$web_dir/imagefiles/$old_imgfilename";
			unlink ($old_img_filename);
			
			$returned = rename("$changed_img_filename","$new_img_filename");
			}

		
		#### EXTRA FIELD/KEY OPERATIONS
		$extra_fk_insert_sql = "";
		$fieldc = 12;
		foreach $k_item (@akeys)
			{
			($keyname, $visible, $size, $searched, $description1, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item);
			
			if ($numberfield eq "Upload")
				{
				
					### DELETE OLD IMAGE IN PERMANENT LOCATION IF MODIFIED LINK UPLOAD HAS NO VALUE
					if ($row[$fieldc] eq "")
						{
						&delete_old_image_if_available($keyname, $row[1]);
						$extra_fk_insert_sql = $extra_fk_insert_sql . ", $keyname" . "_cust = ''";
						}
					### IF NEW UPLOAD FILE OR OLD FILE
					else 
						{
						&copy_del_to_perm_loc($keyname, $row[1], $row[$fieldc]); 
						$extra_fk_insert_sql = $extra_fk_insert_sql . ", $keyname" . "_cust = '$row[$fieldc]'";
						}
				}
				else
				{
				$currentkval = $row[$fieldc]; $currentkval =~ s/'/\\'/g; 
				$extra_fk_insert_sql = $extra_fk_insert_sql . ", $keyname" . "_cust = '$currentkval'";
				}
			
			$fieldc++;
			}
		
		$update_sql = "UPDATE links SET title = '$title', 
												  description = '$description',
												  keywords = '$keywords',
												  url = '$url',
												  name = '$name',
												  email = '$email', $image_ext_update
												  lnkpassword = '$lnkpassword'
												  $extra_fk_insert_sql
												  WHERE lnkid = '$lnkid'";

	
		
		$sth2 = $dbh2->prepare($update_sql);
		$sth2->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		
		### SEND EMAIL IF REQUIRED
		if ($email_status ne "")
			{

			$emailmsg = acs::get_file_contents("$data_dir/accept_modify.eml");
			@elines = split (/\n/, $emailmsg);
			$from_name = $elines[0];
			$from_email = $elines[1];
			$email_subject = $elines[2];
			$lnc = 0;
			
				$email_message = "";
				foreach $line (@elines)
				{
				if ($lnc > 2)
					{
					$email_message = $email_message . $line . "\n";
					}
				$lnc++;
				}			
			
			$email_message =~ s/%%title%%/$title/g;
			$email_message =~ s/%%description%%/$description/g;
			$email_message =~ s/%%url%%/$url/g;
			$email_message =~ s/%%keywords%%/$keywords/g;
			$email_message =~ s/%%email%%/$email/g;
			
			### EXTRA FIELDS 12
			$ekcount = 12;
			foreach $k_item (@akeys)
			{
			($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item);
			
			$ekdata = $row[$ekcount];
			
			if ($ekdata eq "") { $ekdata = "$na"; }
			
			$email_message =~ s/%%$keyname%%/$ekdata/g;
			
			$ekcount++;
			}

			#$sendername1, $fromemail1, $toemail1, $mail_subject1, $email_message1
			acs::send_email ($from_name, $from_email, $email, $email_subject, $email_message);
			}
		
		}


if (defined($sth2))
	{
	$sth2->finish;
	} 
$dbh2->disconnect;


### DELETE APPROVED MODIFIED

$sth = $dbh->prepare($sql_del);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_del";}




#### UPDATE IMAGE DETAILS
foreach $item (@img_to_rem)
	{
	$sql = "UPDATE links SET image = '' WHERE lnkid = '$item'";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	}


$sth->finish;
$dbh->disconnect;

#################

$hbox = acs::get_heading_box("$web_url/ic_modif.gif", "Modification(s) Approved", qq[
$approval_count has been approved.<BR>
<b><a href="$admin_url/admin18.cgi">Click here to continue.</a></b>
]); 


print <<END_OF_APP;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

END_OF_APP

}




sub start
{

$gsettings = new_gsettings acs;
if (($gsettings->{image_width} > 0) and ($gsettings->{image_height} > 0))
	{
	$width = $gsettings->{image_width};
	$height = $gsettings->{image_height};
	$imgwh = qq[width="$width" height="$height"];
	}

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

## 11
## 18

### FOR DEAD LINK CHECKING

$sth = $dbh->prepare("SELECT COUNT(*) FROM modified");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ){$modified_rows = $row[0];}

### EXTRA FIELDS/KEY OPPS

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item);
	$modified_links_sql = $modified_links_sql . ", A." . $keyname . "_cust";
	$links_sql = $links_sql . ", B." . $keyname . "_cust";
	}

										##19 35
$sth = $dbh->prepare("SELECT 	A.mdfid, A.lnkid, A.cid, A.title, A.description, A.keywords, A.url, A.name, A.email, A.urldate, A.lnkpassword, A.notes,
										B.title, B.description, B.keywords, B.url, B.name, B.email, B.lnkpassword, B.urldate,
										C.l1, C.l2, C.l3, C.l4, C.l5, C.l6, C.l7, C.l8, C.l9, C.l10, C.l11, C.l12, C.l13, C.l14, C.l15, C.l16,
										B.premium, B.subs_expire, B.image, B.lnkid
										$modified_links_sql
										$links_sql
							 FROM 
							 modified AS A,
		       			 links AS B,
		       			 dirs AS C
		       			 WHERE 
		       			 (A.cid = C.cid)
		       			 AND
		       			 (A.lnkid = B.lnkid)
		       			 ORDER BY A.title");

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";} 
$rows = $sth->rows();


$acnt = 0;
$total_links = 0;

$mcntr = 1;
$chbcount = 0;


$icnt = $rows;
$nr_searchres = 30;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

$nowtime = time();




#######################################################

while ( @row = $sth->fetchrow() )
	{

 if (($ippc > $st) and ($ippc <= $nd))
   {

	$modified_date = acs::decode_date($row[9]);
	$real_date = acs::decode_date($row[19]);

	### GET CATEGORY
	
	$cats = "";
	for ($ms = 20; $ms < 36; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$cats = $cats . $row[$ms] . "/";
			}
		}

	$ecat = "";
	@acts = split (/\//, $cats);
	foreach $citem (@acts)
		{
		$ecat = $ecat . acs::encode_dir($citem) . "-";
		}
	chop($ecat);
	
	$sel_allv = $sel_allv . "'C" . $chbcount . "',";
	
	$checkbox_name = "C" . $chbcount;

	##### KEY OPERATIONS
	$filesize = ""; $filesize2 = "";
	$extrak_modified = "";
	$extrak_not_modified = "";
	#$ef_pos = 36;
	$ef_pos = 40;

	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $na, $imagef, $numberfield, $req) = split (/\t/, $k_item);
		
		$rowpos = $ef_pos + $knr;
		
		if ($numberfield eq "Upload")
			{

				$modupfile = $keyname . "." . $row[$ef_pos];
				if ((-e "$web_dir/edt/tmp/$row[1]/$modupfile") > 0) 
					{
					$filesize = (-s "$web_dir/edt/tmp/$row[1]/$modupfile"); $filesize = $filesize / 1000; $filesize = sprintf("%5.2f",$filesize);
					$modified_file = qq[<a href="$web_url/edt/tmp/$row[1]/$modupfile" target="_blank">$modupfile</a> (Size: $filesize k)]; 
					}
				else { $modified_file = "None"; }
				
				
				$orig_modupfile = $keyname . "." . $row[$rowpos];
				if ((-e "$web_dir/imagefiles/$row[1]/$orig_modupfile") > 0) 
					{
					$filesize2 = (-s "$web_dir/imagefiles/$row[1]/$orig_modupfile"); $filesize2 = $filesize2 / 1000; $filesize2 = sprintf("%5.2f",$filesize2);
					$orig_upfile = qq[<a href="$web_url/imagefiles/$row[1]/$orig_modupfile" target="_blank">$orig_modupfile</a> (Size: $filesize2 k)]; 
					}
				else {$orig_upfile = "None"; }
				
			$extrak_modified = $extrak_modified . qq[ <tr>
		    <td width="50%" valign="top" bgcolor="#F5F5FA" class="normaltext"><b><font color="#800000">$description</font></b>: $modified_file</td>
		    <td width="50%" valign="top" class="normaltext" bgcolor="#F5F5FA"><b><font color="#800000">$description</font></b>: $orig_upfile</td>
			 </tr>
			];
			}
			elsif ($imagef eq "Yes")
			{
			if ($row[$ef_pos] eq "") { $row[$ef_pos] = $na; }
			if ($row[$rowpos] eq "") { $row[$rowpos] = $na; }
			$extrak_modified = $extrak_modified . qq[<tr><td width="50%" valign="top" bgcolor="#F5F5FA" class="normaltext"><b><font color="#008040">$description</font></b>: $row[$ef_pos]</td><td width="50%" valign="top" class="normaltext" bgcolor="#F5F5FA"><b><font color="#008040">$description</font></b>: $row[$rowpos]</td></tr>];
			}
			else
			{
			if ($row[$ef_pos] eq "") { $row[$ef_pos] = $na; }
			if ($row[$rowpos] eq "") { $row[$rowpos] = $na; }
			$extrak_modified = $extrak_modified . qq[<tr><td width="50%" valign="top" bgcolor="#F5F5FA" class="normaltext"><b><font color="#8080C0">$description</font></b>: $row[$ef_pos]</td><td width="50%" valign="top" class="normaltext" bgcolor="#F5F5FA"><b><font color="#8080C0">$description</font></b>: $row[$rowpos]</td></tr>];
			}
		

			#$extrak_modified = $extrak_modified . "<b>$description</b>: $row[$ef_pos]<br>";
			#$extrak_not_modified = $extrak_not_modified . "<b>$description</b>: $row[$ef_pos + $knr]<br>";

		$ef_pos++;
		}



### IF LINK IS A PREMIUM LINK MARK AS PREMIUM LINK
$prem_link = "";
if ($row[37] < 1) { $row[37] = "9999999999999999999999"; }
if (($row[36] > 0) and ($row[37] > $nowtime))
{
$prem_link = qq[
<font color="#FF0000"><strong>(Premium Link)</strong></font>
];
}



### IF LINK HAS A NEW UPLOADED IMAGE (TAHT WAS NEWLY UPLOADED WHEN MODIFIED
$image_disp = "";

if ($row[38] ne "")
{

$fname = "$web_dir/imagefiles/$row[39]" . "." . $row[38];
if (-e "$fname")
{


	if ((lc($row[38]) eq "tif") or (lc($row[38]) eq "png") or (lc($row[38]) eq "jpg") or (lc($row[38]) eq "jpeg") or (lc($row[38]) eq "gif") or (lc($row[38]) eq "bmp"))
	{

		$ofnm = $row[39] . "." . $row[38];
		$image_disp = qq[<BR><img src="$web_url/imagefiles/$ofnm" $imgwh><BR>];
		
	}
	else
	{
		$image_disp = qq[<font face="Verdana" size="1"><b>File:</b> <a href="$web_url/imagefiles/$row[39].$row[38]" target="_blank">$row[39].$row[38]</a><BR><BR></font>];
	}

}

}



### IF THE IMAGE OF MODIFIED LINK WAS CHANGED
$changed_image = "";

if ($row[11] =~ /:::IMGF:::/)
	{
	($notes, $imgfilename, $oldimgfilename) = split (/:::IMGF:::/, $row[11]);
			
			if ($imgfilename ne "DEL") ### IF IMAGE WAS NOT CHOSEN TO BE DELETED AND NEW IMAGE WAS UPLOADED
				{
				($basename, $bext) = split (/\./, $imgfilename);

					if ((lc($bext) eq "tif") or (lc($bext) eq "png") or (lc($bext) eq "jpg") or (lc($bext) eq "jpeg") or (lc($bext) eq "gif") or (lc($bext) eq "bmp"))
					{
					$changed_image = qq[<img src="$web_url/imagefiles/$imgfilename" $imgwh><BR><BR>];
					}
					else
					{
					$changed_image = qq[<font face="Verdana" size="1"><b>File:</b> <a href="$web_url/imagefiles/$imgfilename" target="_blank">$imgfilename</a><BR><BR></font><BR><BR>];
					}
				
				
				
				}
				
	if ($notes eq "") { $notes = "None"; }
	}
	else
	{
	$notes = $row[11];
	if ($notes eq "") { $notes = "None"; }
	

		$cimgf = "$web_dir/imagefiles/$row[39]" . "." . $row[38];
		if (-e "$cimgf")
			{
			
				if ((lc($row[38]) eq "tif") or (lc($row[38]) eq "png") or (lc($row[38]) eq "jpg") or (lc($row[38]) eq "jpeg") or (lc($row[38]) eq "gif") or (lc($row[38]) eq "bmp"))
					{
					$oldimgl =  "$web_url/imagefiles/$row[39]" . "." . $row[38];
					$changed_image =  qq[<img src="$oldimgl" $imgwh><BR><BR>];
					}
					else
					{
					$changed_image = qq[<font face="Verdana" size="1"><b>File:</b> <a href="$web_url/imagefiles/$row[39].$row[38]" target="_blank">$row[39].$row[38]</a><BR><BR></font>];
					}
			}
			
			
	}


	
$modified_links = $modified_links . <<ENDOFML;

<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#D8D8D8">
  <tr>
    <td width="50%" valign="top" class="normaltext" background="$web_url/bar6.gif"><input
    type="checkbox" name="$checkbox_name" value="$row[0]-$row[1]"> <strong>Modified: $prem_link</strong></td>
    <td width="50%" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Original:
    (Before Modification) $prem_link</strong></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext"> <b>$mcntr. <a href="$row[6]"
    target="_blank">$row[3]</a></b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF"><b>$mcntr. <a
    href="$row[15]" target="_blank">$row[12]</a></b></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b></b>$row[4]<b></b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF"><b></b>$row[13]<b></b></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>$row[6] </b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF"><b>$row[15] </b></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b></b><strong>Keywords: </strong>$row[5] <b></b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF"><b></b><strong>Keywords:
    </strong>$row[14] <b></b></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext">Date:<b> $modified_date</b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF">Date: <b>$real_date</b></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext">Name: <b>$row[7]</b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF">Name: <b>$row[16]</b></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext">Email: <b>$row[8]</b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF">Email: <b>$row[17] </b></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b></b>Password: <b>$row[10] </b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF"><b></b>Password: <b>$row[18]
    </b></td>
  </tr>
  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Image/File:</strong><br>
    $changed_image<b></b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF"><b></b><strong>Image/File:</strong>
    $image_disp <b></b></td>
  </tr>  
  $extrak_modified

  <tr>
    <td width="50%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b><font color="#FF0000">User Notes:</font> </b>$notes<b></b></td>
    <td width="50%" valign="top" class="normaltext" bgcolor="#FFFFFF"><b></b></td>
  </tr>
  <tr>
    <td width="100%" colspan="2" bgcolor="#FFFFFF" class="normaltext"><strong>From: </strong><a
    href="$admin_url/admin12.cgi?ct=$ecat&amp;fct=gotocat&amp;cid=$row[2]&amp;C0=$row[0]"
    onClick="self.opener.location='$admin_url/admin12.cgi?ct=$ecat&amp;fct=gotocat&amp;cid=$row[2]&amp;C0=$row[0]'; self.opener.focus(); return false;"><b>$cats</b>
    </a></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

ENDOFML
	
	
	$chbcount++;
	
 }	
$mcntr++;
$ippc++;
}


#### PAGES 

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		$pgstring = $pgstring . "<a href=\"$admin_url/admin18.cgi?st=$st1&nd=$nd1\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}




### PREV NEXT PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin18.cgi?st=$st1&nd=$nd1\">Next Page </a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin18.cgi?st=$st1&nd=$nd1\"> Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

if ($rows > 0)
	{
	$prnxt =  "$prevnext $myspacer Page $targpage of $pg";
	}






##############

chop($sel_allv);


if ($rows > 0) { $checkboxtext = qq[<b>Check the checkboxes to perform operations on the 'Modified Links'.</b>];}

$hbox = acs::get_heading_box("$web_url/ic_modif.gif", "Modified Listings", qq[
$rows links that needs approval. $checkboxtext
]);
 


print <<ENDOFT;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
      if (popupwin == null || popupwin.closed)
			{
            popupwin = window.open (loc, 'popupwin2', myspecs);
           }
		 else
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }

function checkall(formname,thestate)
	{
	BoxNames=new Array($sel_allv)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

 // End Hide -->
 </script>

</head>
<body>

$hbox

ENDOFT

if ($rows < 1)  ### IF THERE ARE NO MODIFIED LINKS
	{
	
	#### CHECK FOR TO SEE IF THERE ARE DEAD LINKS AND CLEAN UP IF DEAD LINKS FOUND
	if (($rows == 0) and ($modified_rows > 0))
		{
		$sth = $dbh->prepare("DELETE FROM modified");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		}


	### CLEAN UP TEMPORARY UPLOAD DIR
	&mkdirps("$web_dir/edt");
	&mkdirps("$web_dir/edt/tmp");

	opendir(DDR,"$web_dir/edt/tmp");
	my @bdfiles = readdir(DDR);
	closedir (DDR); 
	
		foreach $ditem (@bdfiles)
			{
			if (((-d "$web_dir/edt/tmp/$ditem") > 0) and ($ditem ne ".") and ($ditem ne ".."))
				{
				opendir (DELD,"$web_dir/edt/tmp/$ditem");
					my @filesdel = readdir(DELD);
						foreach $dfilen (@filesdel)
							{
								if (($dfilen ne ".") and ($dfilen ne ".."))
									{
									unlink ("$web_dir/edt/tmp/$ditem/$dfilen");
									}
							}
				closedir (DELD);
				rmdir("$web_dir/edt/tmp/$ditem");
				}
			}

	
	$sth->finish;
	$dbh->disconnect;
	print "</body></html>";
	exit;
	}






print <<END_OF_ML;


<form name="select_all" method="POST" action="$admin_url/admin18.cgi">
  <input type="hidden" name="fct" value="modified_opp"><input type="hidden" name="itemnrs"
  value="$chbcount"><p>$modified_links 
  <img src="$web_url/dbut2.gif"><select name="faction" size="1">
    <option value="approve_email">Approve Selected &amp; Email Acceptance Email</option>
    <option value="approve">Approve Selected &amp; Don't Email Acceptance</option>
    <option value="discard_email">Remove/Discard Selected From Queue (Changes Not Approved) &amp; Email Rejection</option>
    <option value="discard">Remove/Discard Selected From Queue (Changes Not Approved) &amp; Don't Email Rejection</option>
    <option value="edit">Edit Selected Modifications</option>
  </select><input type="submit" value="Submit" name="B1"> </p>
</form>


<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="50%" class="normaltext">$prnxt </td>
    <td width="50%" align="right" class="normaltext">$pgstring </td>
  </tr>
  <tr>
    <td class="normaltext"><span class="style1"><a href="javascript:checkall('select_all',true)">Check All </a>| <a
href="javascript:checkall('select_all',false)">UnCheck All </a></span></td>
    <td align="right" class="normaltext">&nbsp;</td>
  </tr>
</table>

<ul><li class="normaltext"><a href="$admin_url/admin19.cgi?fct=accept_modification&amp;from=modif">Edit Acceptance
    Email </a>
</li>
  <li class="normaltext"><a href="$admin_url/admin19.cgi?fct=reject_modification&amp;from=modif">Edit Rejection
    Email </a></li>
</ul>

END_OF_ML



$sth->finish;
$dbh->disconnect;

}


sub copy_del_to_perm_loc
{
($ckeyname, $clnkid, $cfext) = @_;

$c_orig_file = "$web_dir/edt/tmp/$clnkid/$ckeyname" . "." . $cfext;

&mkdirps("$web_dir/imagefiles");
&mkdirps("$web_dir/imagefiles/$clnkid");

$new_file = "$web_dir/imagefiles/$clnkid/$ckeyname" . "." . $cfext;

	open (UPLOADFILE, "$c_orig_file");
	open (UPLWRITE, "> $new_file");

	  binmode (UPLOADFILE);
	  binmode (UPLWRITE);
			  
			  	while (defined($line=<UPLOADFILE>))
					{
					print UPLWRITE $line;
					}
			 
	close (UPLOADFILE);
	close (UPLWRITE); 

unlink ($c_orig_file);

}




sub delete_old_image_if_available
{
($dkey, $del_lnkid) = @_;

opendir(DDR,"$web_dir/imagefiles/$del_lnkid");
my @bdfiles = readdir(DDR);
closedir (DDR); 

	foreach $ditem (@bdfiles)
		{
		if (substr($ditem, 0, length($dkey)) eq $dkey)
			{
			unlink ("$web_dir/edt/tmp/$uplnkid/$ditem");
			}
		}


}





####################################################################################






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

